#include <stdio.h>
#include <stdlib.h>
#include <alloc.h>
#include <string.h>
#include "XMS.H"

#define NITEMS1   4
#define NITEMS2   8
#define NFRIENDS  50000l
#define KBYTE     1024l

typedef struct{   char  friend1[20];
                  char  friend2[20];
                  char  friend3[20];   }  friends;

void error(char *s)
{
   printf(s);
   printf(". error type: BL_Info=%x", BL_Info);
   exit(1);
}

void main(void)
{
   unsigned       h1[100], h2[100];
   unsigned far   *mem;
   unsigned       i, k, handles, freemem;
   EMB_Array      MyArray;
   unsigned long  n;
   friends far    *buffer;


   mem=(unsigned far *)farmalloc(60*KBYTE);
   for(i=0; i<30*KBYTE; ++i) mem[i]=i;
   if(!XMS_Install())
      error("XMS_Install fails");
   if(!(handles=XMS_FreeHandles()))
      error("no handles available");
   if(!(freemem=XMS_FreeSize()))
      error("no memory available");

   for(i=0; i<(handles-1)/2; ++i)
   {
      if(!(h1[i]=XMS_Alloc(60)) || !(h2[i]=XMS_Alloc(60)))
         error("XMS_Alloc fails");
      if(!XMS_ConvToExt(60*KBYTE, mem, h1[i]))
         error("XMS_ConvToExt fails");
      if(!XMS_ExtToExt(h1[i], h2[i]))
         error("XMS_ExtToExt fails");
   }
   printf("\nwrote %d Kbytes into EMBs and made a copy of it...\n",
                                                   60*(handles-1)/2);

   for(i=0; i<(handles-1)/2; ++i)
   {
      for(k=0; k<30*KBYTE; ++k) mem[k]=0;
      if(XMS_ExtToConv(60*KBYTE, h1[i], mem)!=1)
         error("XMS_ExtToConv fails");
      if(!XMS_Free(h1[i]))
         error("XMS_Free fails");
      for(k=0; k<30*KBYTE; ++k)
         if(mem[k]!=k)
            error("not matching data with 1st allocation");

      for(k=0; k<30*KBYTE; ++k) mem[k]=0;
      if(XMS_ExtToConv(60*KBYTE, h2[i], mem)!=1)
         error("XMS_ExtToConv fails");
      if(!XMS_Free(h2[i]))
         error("XMS_Free fails");
      for(k=0; k<30*KBYTE; ++k)
         if(mem[k]!=k)
            error("not matching data with 2nd allocation");
   }

   printf("\nfree handles were: %d", handles);
   printf("\nfree memory was: %dK", freemem);
   printf("\nfree memory is: %dK\n", XMS_FreeSize());
   puts("\nsending to EMBs and getting from works OK!");
   farfree(mem);


   buffer=(friends *)farmalloc(NITEMS1*sizeof(friends));

   if(!XMS_ArrayAlloc(NFRIENDS, sizeof(friends), &MyArray)) error("XMS_ArrayAlloc fails");
   printf("\nbig allocation test started. EMB_Array size=%dK\n", XMS_ArraySize(&MyArray));
   
   for(i=0; i<NITEMS1; ++i)
   {
      strcpy(buffer[i].friend1,"Donald Duck");
      strcpy(buffer[i].friend2,"Mickey Mouse");
      strcpy(buffer[i].friend3,"Uncle Scrooge");
   }

   for(n=0; n<NFRIENDS; n=n+NITEMS1)
      if(!XMS_ArrayWrite(buffer, &MyArray, n, NITEMS1)) error("XMS_ArrayWrite fails");
   
   farfree(buffer);
   buffer=(friends *)farmalloc(NITEMS2*sizeof(friends));
   for(n=0; n<NFRIENDS; n=n+NITEMS2)
   {
      if(!XMS_ArrayRead(&MyArray, n, buffer, NITEMS2)) error("XMS_ArrayRead fails");
      for(i=0; i<NITEMS2; ++i)
      {
         if(_fstrcmp(buffer[i].friend1,"Donald Duck")) error("not matching data with EMB_Array");
         if(_fstrcmp(buffer[i].friend2,"Mickey Mouse")) error("not matching data with EMB_Array");
         if(_fstrcmp(buffer[i].friend3,"Uncle Scrooge")) error("not matching data with EMB_Array");
      }
   }
   puts("big allocation test with EMB_Array is OK!");
   
   if(!XMS_ArrayFree(&MyArray)) error("XMS_ArrayFree fails");
   if(!XMS_Destall()) error("XMS_Destall fails");
}