#include <stdio.h>
#include <stdlib.h>
#include <alloc.h>
#include <string.h>
#include <conio.h>
#include <time.h>
#include "XMS.H"

#define NINT         2000000l
#define ITERATIONS   10

void error(char *s)
{
   printf(s);
   printf(" error type: BL_Info=%x", BL_Info);
   exit(1);
}

void main(void)
{
   EMB_Array far  *MyArray;
   unsigned long  i;
   unsigned long  NITEMS[4]={10l, 100l, 1000l, 10000l};
   float          t;
   int            n, k;
   int far        *buffer;
   clock_t        start, end;

   MyArray=(EMB_Array *)farmalloc(sizeof(EMB_Array));

   if(!XMS_Install()) error("XMS_Install fails");
   if(!XMS_ArrayFarAlloc(NINT, sizeof(int), MyArray)) error("XMS_ArrayAlloc fails");
   printf("\nblock size=%dK", XMS_ArrayFarSize(MyArray));
   printf("\nItemSize=%d byte(s)\n\n", MyArray->ItemSize);

   for (k=0; k<4; ++k)
   {
      buffer=(int *)farmalloc(NITEMS[k]*sizeof(int));
      printf("buffer size is now: %d items\n", NITEMS[k]);

      start=clock();
      for(n=0; n<ITERATIONS; ++n)
      {
         for(i=0; i<NINT; i=i+NITEMS[k])
            if(!XMS_ArrayFarWrite(buffer, MyArray, i, NITEMS[k])) error("XMS_ArrayWrite fails");
         putch('.');
      }
      end=clock();

      printf("\ntime taken to transfer %ld integers %d times: %.1f s\n", NINT, ITERATIONS, t=(end-start)/CLK_TCK);
      printf("transfer rate: %.1f byte/s\n\n", (2l*NINT*ITERATIONS)/t);

      farfree(buffer);
   }

   if(!XMS_ArrayFarFree(MyArray)) error("XMS_ArrayFarWrite fails");
   if(!XMS_Destall()) error("XMS_Destall fails");
}